MapExtension.Events.Achievement = {
	Preload = {},
	List = {},
	ReqList = {}
}

function MapExtension.Events.Achievement.Scan ()
	for dk, dv in pairs(MapExtension.Data.Tracking) do
		if dv.Achievement ~= nil then
			for k, v in pairs(dv.Achievement) do
				MapExtension.Events.Achievement.Preload[v] = dk
			end
		end
	end
end

function MapExtension.Events.Achievement.AsyncLoad ()
	while Inspect.System.Watchdog() > 0.1 and tablelength(MapExtension.Events.Achievement.Preload) > 0 and Inspect.Time.Server() - MapExtension.AE.InitTime > 5 do
		local achievementId = next(MapExtension.Events.Achievement.Preload)
		local achievement = Inspect.Achievement.Detail(achievementId)

		if achievement ~= nil then
			MapExtension.Events.Achievement.List[achievementId] = { id = MapExtension.Events.Achievement.Preload[achievementId], count = 0, completed = 0 }

			for rk, rv in pairs(achievement.requirement) do
				local name = string.trim(rv.name)

				if MapExtension.Tracking.ScanListTranslate[name] ~= nil then
					MapExtension.Events.Achievement.ReqList[MapExtension.Tracking.ScanListTranslate[name]] = (rv.complete or false)
					MapExtension.Events.Achievement.List[achievementId].completed = MapExtension.Events.Achievement.List[achievementId].completed + iif(rv.complete, 1, 0)
					MapExtension.Events.Achievement.List[achievementId].count = MapExtension.Events.Achievement.List[achievementId].count + 1
				end
			end

			MapExtension.Events.Achievement.Preload[achievementId] = nil
		end

		MapExtension.Events.Achievement.UpdateCounters()
	end
end

function MapExtension.Events.Achievement.Complete (handle, element)
	if MapExtension.Events.Achievement.List[element] ~= nil and MapExtension.Events.Achievement.Preload[element] == nil then
		local achievement = Inspect.Achievement.Detail(element)
		local list = {}
		MapExtension.Events.Achievement.List[element].completed = 0

		for rk, rv in pairs(achievement.requirement) do
			local name = string.trim(rv.name)

			if MapExtension.Tracking.ScanListTranslate[name] ~= nil then
				MapExtension.Events.Achievement.List[element].completed = MapExtension.Events.Achievement.List[element].completed + iif(rv.complete, 1, 0)
				name = MapExtension.Tracking.ScanListTranslate[name]

				if MapExtension.Events.Achievement.ReqList[name] ~= (rv.complete or false) then
					MapExtension.Events.Achievement.ReqList[name] = (rv.complete or false)
					table.insert(list, name)
				end
			end
		end

		if #list == 1 then
			local player = Inspect.Unit.Detail("player")
			MapExtension.Tracking.AddElement({ id = element, description = list[1], coordX = player.coordX, coordY = player.coordY, coordZ = player.coordZ }, 3)
		end

		MapExtension.Events.Achievement.UpdateCounters()
	end
end

function MapExtension.Events.Achievement.Update (handle, elements)
	for k,v in pairs(elements) do
		MapExtension.Events.Achievement.Complete(handle, k)
	end
end

function MapExtension.Events.Achievement.UpdateCounters ()
	for k, v in pairs(MapExtension.Tracking.AchievementList) do
		MapExtension.Tracking.AchievementList[k].count = 0
		MapExtension.Tracking.AchievementList[k].completed = 0
	end

	for k, v in pairs(MapExtension.Events.Achievement.List) do
		MapExtension.Tracking.AchievementList[v.id].count = MapExtension.Tracking.AchievementList[v.id].count + v.count
		MapExtension.Tracking.AchievementList[v.id].completed = MapExtension.Tracking.AchievementList[v.id].completed + v.completed
	end

	MapExtension.Menu.Tracking.UpdateCounters()
end