MapExtension.GUI.Tooltip = {}

function MapExtension.GUI.Tooltip.Init (parent)
	MapExtension.GUI.Tooltip.window = MapExtension.GUI.Basic.CreateFrame(parent, "CENTER", 0, 0, 320, 100, 100)
	MapExtension.GUI.Tooltip.window:SetVisible(false)

	MapExtension.GUI.Basic.CreateTexture(MapExtension.GUI.Tooltip.window, 0, 0, 320, 12, 0, "img/tooltip320-top.png", "TOPLEFT")
	MapExtension.GUI.Basic.CreateTexture(MapExtension.GUI.Tooltip.window, 0, 0, 320, 26, 0, "img/tooltip320-bottom.png", "BOTTOMLEFT")
	MapExtension.GUI.Tooltip.background = MapExtension.GUI.Basic.CreateTexture(MapExtension.GUI.Tooltip.window, 0, 12, 320, 50, 0, "img/tooltip320-middle.png", "TOPLEFT")
	MapExtension.GUI.Basic.CreateTexture(MapExtension.GUI.Tooltip.background, 5, -29, 320, 5, 0, "img/tooltip-separator.png", "BOTTOMLEFT")

	MapExtension.GUI.Basic.CreateText(MapExtension.GUI.Tooltip.background, "BOTTOMLEFT", 20, -4, MapExtension.Data.Language.Current.Location)
	MapExtension.GUI.Tooltip.fields = {
		text = {},
		name = MapExtension.GUI.Basic.CreateText(MapExtension.GUI.Tooltip.background, "TOPLEFT", 20, 3, "", nil, 16, { 1, 0.8, 0.2, 1 }),
		type = MapExtension.GUI.Basic.CreateText(MapExtension.GUI.Tooltip.background, "TOPRIGHT", -20, 5),
		location = MapExtension.GUI.Basic.CreateText(MapExtension.GUI.Tooltip.background, "BOTTOMRIGHT", -20, -4),
	}

	for i = 1, 50 do
		MapExtension.GUI.Tooltip.fields.text[i] = MapExtension.GUI.Basic.CreateText(MapExtension.GUI.Tooltip.background, "TOPLEFT", 20, i * 20 - 17)
	end
end

function MapExtension.GUI.Tooltip.Show (id, parent)
	local height = 82 + 20 * iif(parent.data.list == nil, 1, tablelength(parent.data.list))
	MapExtension.GUI.Tooltip.id = id

	for i = 1, 50 do
		MapExtension.GUI.Tooltip.fields.text[i]:SetText("")
	end

	if parent.data.list == nil then
		MapExtension.GUI.Tooltip.fields.name:SetText(parent.data.caption)
		MapExtension.GUI.Tooltip.fields.type:SetText(parent.data.type)
		MapExtension.GUI.Tooltip.fields.location:SetText(math.floor(parent.position.x) .. ", " .. math.floor(parent.position.y))
	else
		local i = 1
		for k, v in pairs(parent.data.list) do
			MapExtension.GUI.Tooltip.fields.text[i]:SetText(MapExtension.Tracking.ScanList[k].name)
			i = i + 1
		end

		MapExtension.GUI.Tooltip.fields.name:SetText("")
		MapExtension.GUI.Tooltip.fields.type:SetText("")
		MapExtension.GUI.Tooltip.fields.location:SetText(math.floor(parent.position.x) .. ", " .. math.floor(parent.position.y))
	end

	MapExtension.GUI.Tooltip.window:SetHeight(height)
	MapExtension.GUI.Tooltip.background:SetHeight(height - 38)
	MapExtension.GUI.Tooltip.window:SetPoint("CENTER", parent, "CENTERRIGHT", MapExtension.GUI.Tooltip.window:GetWidth() / 2, 0)
	MapExtension.GUI.Tooltip.window:SetVisible(true)
end

function MapExtension.GUI.Tooltip.Hide (id)
	if MapExtension.GUI.Tooltip.id == id or id == nil then
		MapExtension.GUI.Tooltip.window:SetVisible(false)
	end
end
