function MapExtension.AE.Init (handle, addonIdentifier)
	MapExtension.AE.UI.Context = UI.CreateContext(MapExtensionAddon.identifier)
	MapExtension.AE.UI.MapTexture = { active = 0 }
	MapExtension.AE.UI.MapSelector = {}
	MapExtension.AE.Language = Inspect.System.Language()
	MapExtension.Data.Language.Current = MapExtension.Data.Language[MapExtension.AE.Language]

	MapExtension.Async.Init()

	MapExtension.AE.InitSettings()
	MapExtension.Update.FixData()
	MapExtension.Update.PreloadData()
	MapExtension.AE.CreateButton()
	MapExtension.AE.CreateWindow()
	MapExtension.AE.CreateMarks()

	MapExtension.Menu.Options.Init(MapExtension.AE.UI.Options)
	MapExtension.Menu.Tracking.Init(MapExtension.AE.UI.Tracking)

	MapExtension.Tracking.Init()
	MapExtension.Events.Achievement.Scan()
	MapExtension.Messenger.Send(MapExtension.Messenger.MessageVersion, MapExtensionAddon.toc.Version)
	MapExtension.Async.Start()

	Command.Console.Display("general", true, "<font color=\"#AD48FB\">" .. MapExtensionAddon.name .. " ver." .. MapExtensionAddon.toc.Version .. MapExtension.Data.Language.Current.Load1 .. MapExtension.AE.Command .. MapExtension.Data.Language.Current.Load2 .. "</font>", true)
	MapExtension.AE.InitTime = Inspect.Time.Server()
	MapExtension.CreateEvents ()
end

function MapExtension.AE.CreateButton ()
	MapExtension.AE.UI.Button = MapExtension.GUI.Basic.CreateButton(MapExtension.AE.UI.Context, iif(MINIMAPDOCKER, nil, MapExtensionUISettings.button.x), iif(MINIMAPDOCKER, nil, MapExtensionUISettings.button.y), 32, 32, 0, "button")
	if MINIMAPDOCKER then
		MINIMAPDOCKER.Register(MapExtensionAddon.toc.Name, MapExtension.AE.UI.Button, MapExtension.AE.ToggleWindow)
	else
		MapExtension.GUI.Extended.AttachDragFrame(MapExtension.AE.UI.Button, false, "button", false)
	end
	MapExtension.AE.UI.Button.Event.LeftClick = MapExtension.AE.ToggleWindow
end

function MapExtension.AE.CreateWindow ()
	MapExtension.AE.UI.Window = UI.CreateFrame("RiftWindow", "", MapExtension.AE.UI.Context)
	MapExtension.AE.UI.Window:SetVisible(MapExtension.AE.Visible)
	MapExtension.AE.UI.Window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", MapExtensionUISettings.window.x, MapExtensionUISettings.window.y)
	MapExtension.AE.UI.Window:SetWidth(MapExtensionUISettings.window.width)
	MapExtension.AE.UI.Window:SetHeight(MapExtensionUISettings.window.height)
	MapExtension.AE.UI.Window:SetTitle(string.upper(MapExtensionAddon.toc.Name))
	MapExtension.AE.UI.Window:SetController("content")
	MapExtension.AE.UI.Window:SetLayer(100)
	MapExtension.GUI.Extended.AttachDragFrame(MapExtension.AE.UI.Window, true, "window", true)
	MapExtension.GUI.Extended.AttachResizableFrame(MapExtension.AE.UI.Window, "window", 400, 320)

	for mk, mv in pairs(MapExtension.Data.Maps) do
		MapExtension.AE.UI.MapTexture[mk] = MapExtension.GUI.Texture:CreateView(MapExtension.AE.UI.Window, mk, 0, 10, 30, 10, 1, "img/map/" .. mk .. "/", mv.width, mv.height, 256, { x = mv.offsetx, y = mv.offsety })
		MapExtension.AE.UI.MapTexture[mk]:SetBackgroundColor(.234375, .2421875, .234375)
		table.insert(MapExtension.AE.UI.MapTexture[mk].MousePosition, MapExtension.AE.OnMousePosition)

		MapExtension.AE.UI.MapSelector[mk] = MapExtension.GUI.Basic.CreateButton(MapExtension.AE.UI.Window, 75 * mk - 50, -42, 67, 51, 100, "map" .. mk, "BOTTOMLEFT")
		MapExtension.AE.UI.MapSelector[mk].Event.LeftClick = function() MapExtension.AE.ShowMap(mk) end
	end

	MapExtension.GUI.Texture:CreateTile(MapExtension.AE.UI.Window, 0, 10, 30, 10, 17, 17, 2, "img/border.png", "img/borderh.png", "img/borderv.png")
	MapExtension.AE.UI.Coordinates = MapExtension.GUI.Basic.CreateText(MapExtension.AE.UI.Window, "BOTTOMCENTER", 0, -4, "[]", 100, nil, {.75, .75, .75, 1})
	MapExtension.AE.UI.Progress = MapExtension.GUI.Basic.CreateText(MapExtension.AE.UI.Window, "BOTTOMCENTER", 0, -4, "", 100, nil, {.75, .75, .75, 1})
	MapExtension.GUI.Basic.CreateText(MapExtension.AE.UI.Window, "BOTTOMRIGHT", -7, -12, "v." .. MapExtensionAddon.toc.Version, 100, 10, {.5, .5, .5, 1})
	MapExtension.GUI.Basic.CreateText(MapExtension.AE.UI.Window, "BOTTOMRIGHT", -7, -1, "riftutilz.com", 100, 10, {.5, .5, .5, 1})
	MapExtension.GUI.Basic.CreateRiftButton(MapExtension.AE.UI.Window, 4, -41, 2).Event.LeftPress = MapExtension.AE.ToggleWindow

	MapExtension.AE.UI.Switch = MapExtension.GUI.Basic.CreateButton(MapExtension.AE.UI.Window, -120, -3, 24, 24, 100, "switch", "BOTTOMCENTER", true)
	MapExtension.AE.UI.Switch.SetState(MapExtensionUISettings.flags.mapSelector)
	MapExtension.AE.UI.Switch.Event.LeftClick = function() MapExtensionUISettings.flags.mapSelector = not MapExtensionUISettings.flags.mapSelector MapExtension.AE.UI.Switch.state = MapExtensionUISettings.flags.mapSelector MapExtension.AE.OnShowMapSelector() end

	MapExtension.AE.UI.Lock = MapExtension.GUI.Basic.CreateButton(MapExtension.AE.UI.Window, -90, -3, 24, 24, 100, "lock", "BOTTOMCENTER", true)
	MapExtension.AE.UI.Lock.SetState(MapExtensionUISettings.flags.lock)
	MapExtension.AE.UI.Lock.Event.LeftClick = function() MapExtensionUISettings.flags.lock = not MapExtensionUISettings.flags.lock MapExtension.AE.UI.Lock.state = MapExtensionUISettings.flags.lock end

	MapExtension.AE.UI.Options = MapExtension.GUI.Basic.CreateButton(MapExtension.AE.UI.Window, 90, -3, 24, 24, 100, "options", "BOTTOMCENTER")
	MapExtension.AE.UI.Options.Event.LeftClick = function() MapExtension.Menu.Tracking.ToggleWindow(false) MapExtension.Menu.Options.ToggleWindow() end

	MapExtension.AE.UI.Tracking = MapExtension.GUI.Basic.CreateButton(MapExtension.AE.UI.Window, 120, -3, 24, 24, 100, "tracking", "BOTTOMCENTER")
	MapExtension.AE.UI.Tracking.Event.LeftClick = function() MapExtension.Menu.Options.ToggleWindow(false) MapExtension.Menu.Tracking.ToggleWindow() end
end

function MapExtension.AE.CreateMarks ()
	for mk, mv in pairs(MapExtension.Data.Maps) do
		MapExtension.AE.UI.MapTexture[mk]:AddMark("player", "player", { x = 0, y = 0, layer = 1000 }, { caption = "", type = MapExtension.Data.Language.Current.Player }, true, mk)
		for i = 1, 20 do
			MapExtension.AE.UI.MapTexture[mk]:AddMark(string.format("group%.2d", i), "group", { x = 0, y = 0, layer = 900 }, { caption = "", type = MapExtension.Data.Language.Current.Group }, false, mk)
		end
	end
end

function MapExtension.AE.ToggleWindow ()
	local unitDetail = Inspect.Unit.Detail("player")
	if unitDetail ~= nil and MapExtension.Data.Zones[unitDetail.zone] ~= nil then
		MapExtension.AE.UI.MapTexture.active = MapExtension.Data.Zones[unitDetail.zone].map
	end

	if not MapExtension.AE.firstLoad then
		MapExtension.AE.firstLoad = true
		MapExtension.Events.Map.Scan()
	end

	MapExtension.AE.Visible = not MapExtension.AE.Visible
	MapExtension.Menu.Tracking.ToggleWindow(false)
	MapExtension.Menu.Options.ToggleWindow(false)
	MapExtension.AE.OnCoordinatesChanged()
	MapExtension.AE.OnShowMapSelector()
	MapExtension.AE.ShowMap(MapExtension.AE.UI.MapTexture.active)
	MapExtension.AE.UI.Window:SetVisible(MapExtension.AE.Visible)
end

function MapExtension.AE.InitSettings ()
	if MapExtensionUISettings == nil then MapExtensionUISettings = {} end
	if MapExtensionUISettings.button == nil then MapExtensionUISettings.button = { x = -1, y = -1 } end
	if MapExtensionUISettings.window == nil then MapExtensionUISettings.window = { x = -1, y = -1, width = -1, height = -1 } end

	if MapExtensionUISettings.tracking == nil then MapExtensionUISettings.tracking = {} end
	if MapExtensionUISettings.flags == nil then MapExtensionUISettings.flags = {} end
	if MapExtensionUISettings.flags.lock == nil then MapExtensionUISettings.flags.lock = false end
	if MapExtensionUISettings.flags.mapSelector == nil then MapExtensionUISettings.flags.mapSelector = false end
	if MapExtensionUISettings.flags.checkVersion == nil then MapExtensionUISettings.flags.checkVersion = true end
	if MapExtensionUISettings.flags.rareNotification == nil then MapExtensionUISettings.flags.rareNotification = true end
	if MapExtensionUISettings.flags.filter == nil then MapExtensionUISettings.flags.filter = true end

	if MapExtensionUISettings.button.x < 0 or MapExtensionUISettings.button.x > UIParent:GetWidth() - 10 then MapExtensionUISettings.button.x = math.floor(UIParent:GetWidth() / 2) end
	if MapExtensionUISettings.button.y < 0 or MapExtensionUISettings.button.y > UIParent:GetHeight() - 10 then MapExtensionUISettings.button.y = math.floor(UIParent:GetHeight() / 2) end
	if MapExtensionUISettings.window.x < 0 or MapExtensionUISettings.window.x > UIParent:GetWidth() - 10 then MapExtensionUISettings.window.x = math.floor(UIParent:GetWidth() / 4) end
	if MapExtensionUISettings.window.y < 0 or MapExtensionUISettings.window.y > UIParent:GetHeight() - 10 then MapExtensionUISettings.window.y = math.floor(UIParent:GetHeight() / 4) end
	if MapExtensionUISettings.window.width < 0 or MapExtensionUISettings.window.width > UIParent:GetWidth() - 10 then MapExtensionUISettings.window.width = math.floor(UIParent:GetWidth() / 2) end
	if MapExtensionUISettings.window.height < 0 or MapExtensionUISettings.window.height > UIParent:GetHeight() - 10 then MapExtensionUISettings.window.height = math.floor(UIParent:GetHeight() / 2) end

	if MapExtensionTrackingResources == nil then MapExtensionTrackingResources = {} end
end

function MapExtension.AE.OnShowMapSelector ()
	for mk, mv in pairs(MapExtension.Data.Maps) do
		MapExtension.AE.UI.MapSelector[mk]:SetVisible(MapExtensionUISettings.flags.mapSelector)
	end
end

function MapExtension.AE.OnMousePosition (isInner, x, y) 
	MapExtension.AE.CoordinatesType = isInner
	local position = MapExtension.AE.Coordinates
	if isInner then
		position = { x = x, y = y }
	end
	MapExtension.AE.ShowCoordinates(position)
end

function MapExtension.AE.OnCoordinatesChanged ()
	if MapExtension.AE.Visible then
		for i = 1, 21 do
			local name = iif(i == 21, "player", string.format("group%.2d", i))
			local unitDetail = Inspect.Unit.Detail(name)
			local visible = unitDetail ~= nil and unitDetail.coordX ~= nil and unitDetail.coordZ ~= nil and MapExtension.Data.Zones[unitDetail.zone] ~= nil

			for mk, mv in pairs(MapExtension.Data.Maps) do
				MapExtension.AE.UI.MapTexture[mk]:SetVisibleMark(name, visible and MapExtension.Data.Zones[unitDetail.zone].map == mk)
			end

			if visible then
				MapExtension.AE.UI.MapTexture[MapExtension.Data.Zones[unitDetail.zone].map]:SetMarkProperties(name, { x = unitDetail.coordX or 0, y = unitDetail.coordZ or 0 }, unitDetail.name)
			end

			if i == 21 and visible then
				MapExtension.AE.Coordinates = { x = unitDetail.coordX, y = unitDetail.coordZ }
				if not MapExtension.AE.CoordinatesType then MapExtension.AE.ShowCoordinates(MapExtension.AE.Coordinates) end
				if MapExtensionUISettings.flags.lock and (math.abs(MapExtension.AE.Coordinates.x - MapExtension.AE.OldCoordinates.x) >= 0.5 or math.abs(MapExtension.AE.Coordinates.y - MapExtension.AE.OldCoordinates.y) >= 0.5) then
					MapExtension.AE.OldCoordinates = MapExtension.AE.Coordinates
					MapExtension.AE.UI.MapTexture[MapExtension.Data.Zones[unitDetail.zone].map]:SetPosition(MapExtension.AE.Coordinates.x, MapExtension.AE.Coordinates.y)
				end
			end
		end
	end
end

function MapExtension.AE.ShowMap (map)
	local offset = 25
	MapExtension.AE.UI.MapTexture.active = map
	for mk, mv in pairs(MapExtension.Data.Maps) do
		MapExtension.AE.UI.MapTexture[mk]:SetVisible(MapExtension.AE.UI.MapTexture.active == mk)
		MapExtension.AE.UI.MapSelector[mk]:SetVisible(MapExtension.AE.UI.MapTexture.active ~= mk)
		MapExtension.AE.UI.MapSelector[mk]:SetPoint("BOTTOMLEFT", MapExtension.AE.UI.Window, "BOTTOMLEFT", offset, -42)
		offset = offset + iif(MapExtension.AE.UI.MapTexture.active ~= mk, 75, 0)
	end
end

function MapExtension.AE.ShowCoordinates (position)
	MapExtension.AE.UI.Coordinates:SetText("[ " .. math.floor(position.x) .. ", " .. math.floor(position.y) .. " ]")
end
