MapExtension.Menu.Tracking = {
	menus = {},
	fields = {}
}

function MapExtension.Menu.Tracking.Init (parent)
	MapExtension.Menu.Tracking.window = MapExtension.GUI.Basic.CreateFrame(parent, "CENTER", 12, -30 - tablelength(MapExtension.Data.Tracking) * 10, 250, 80 + tablelength(MapExtension.Data.Tracking) * 20, 100, MapExtension.AE.UI.Window)
	MapExtension.Menu.Tracking.window:SetVisible(false)

	MapExtension.GUI.Basic.CreateTexture(MapExtension.Menu.Tracking.window, 0, 0, 250, 12, 0, "img/tooltip250-top.png", "TOPLEFT")
	MapExtension.GUI.Basic.CreateTexture(MapExtension.Menu.Tracking.window, 0, 0, 250, 26, 0, "img/tooltip250-bottom.png", "BOTTOMLEFT")
	MapExtension.Menu.Tracking.background = MapExtension.GUI.Basic.CreateTexture(MapExtension.Menu.Tracking.window, 0, 12, 250, 42 + tablelength(MapExtension.Data.Tracking) * 20, 0, "img/tooltip250-middle.png", "TOPLEFT")
	MapExtension.GUI.Basic.CreateTexture(MapExtension.Menu.Tracking.background, 5, 30, 250, 5, 0, "img/tooltip-separator.png", "TOPLEFT")

	MapExtension.GUI.Basic.CreateText(MapExtension.Menu.Tracking.background, "TOPLEFT", 20, 5, MapExtension.Data.Language.Current.Points)

	local i = 0
	for dk, dv in pairs(MapExtension.Data.Tracking) do
		MapExtension.Menu.Tracking.menus[dk] = { 
			line = MapExtension.GUI.Basic.CreateCheckbox(MapExtension.Menu.Tracking.background, "TOPLEFT", 13, 40 + i * 20, 224, 20, 200, dv.Name[MapExtension.AE.Language], MapExtension.Menu.Tracking.OnFilterChange, MapExtension.Menu.Tracking.ShowSubmenu, dk, MapExtensionUISettings.tracking[dk], nil, dv.Group),
			field = MapExtension.GUI.Basic.CreateText(MapExtension.Menu.Tracking.background, "TOPRIGHT", -20, 40 + i * 20)
		}

		if dv.Group then
			MapExtension.Menu.Tracking.menus[dk].frame = MapExtension.GUI.Basic.CreateFrame(MapExtension.Menu.Tracking.window, "TOPLEFT", 0, 0, 320, 45, 300, MapExtension.AE.UI.Window)
			MapExtension.Menu.Tracking.menus[dk].frame:SetVisible(false)
			MapExtension.GUI.Basic.CreateTexture(MapExtension.Menu.Tracking.menus[dk].frame, 0, 0, 320, 12, 200, "img/tooltip320-top.png", "TOPLEFT")
			MapExtension.GUI.Basic.CreateTexture(MapExtension.Menu.Tracking.menus[dk].frame, 0, 0, 320, 26, 200, "img/tooltip320-bottom.png", "BOTTOMLEFT")
			MapExtension.Menu.Tracking.menus[dk].background = MapExtension.GUI.Basic.CreateTexture(MapExtension.Menu.Tracking.menus[dk].frame, 0, 12, 320, 7, 200, "img/tooltip320-middle.png", "TOPLEFT")

			local c = 0
			for k, v in ipairs(dv.Data) do
				MapExtension.GUI.Basic.CreateCheckbox(MapExtension.Menu.Tracking.menus[dk].background, "TOPLEFT", 13, 1 + c, 294, 20, 200, v.name[MapExtension.AE.Language], MapExtension.Menu.Tracking.OnFilterChange, nil, v.name.English, MapExtensionUISettings.tracking[v.name.English], 'img/icons/' .. v.icon)
				MapExtension.Menu.Tracking.fields[v.name.English] = MapExtension.GUI.Basic.CreateText(MapExtension.Menu.Tracking.menus[dk].background, "TOPRIGHT", -20, 1 + c)
				c = c + 20
			end
			MapExtension.Menu.Tracking.menus[dk].frame:SetHeight(41 + c)
			MapExtension.Menu.Tracking.menus[dk].background:SetHeight(3 + c)
		end
		i = i + 1
	end

	MapExtension.AE.UI.Window.Event.Move = function() MapExtension.Menu.Tracking.SetSubmenuPosition(MapExtension.Menu.Tracking.SelectedSubmenu) end
	MapExtension.AE.UI.Window.Event.Size = function() MapExtension.Menu.Tracking.SetSubmenuPosition(MapExtension.Menu.Tracking.SelectedSubmenu) end
end

function MapExtension.Menu.Tracking.ToggleWindow (flag)
	MapExtension.Menu.Tracking.ShowSubmenu(nil, nil, nil)
	if flag == nil then flag = not MapExtension.Menu.Tracking.window:GetVisible() end
	MapExtension.Menu.Tracking.window:SetVisible(flag)
end

function MapExtension.Menu.Tracking.ShowSubmenu (ctrl, param, value)
	if MapExtension.Menu.Tracking.SelectedSubmenu ~= nil then
		if MapExtension.Menu.Tracking.menus[MapExtension.Menu.Tracking.SelectedSubmenu].frame ~= nil then
			MapExtension.Menu.Tracking.menus[MapExtension.Menu.Tracking.SelectedSubmenu].frame:SetVisible(false)
		end
		MapExtension.Menu.Tracking.menus[MapExtension.Menu.Tracking.SelectedSubmenu].line.SetHighlight(false)
	end

	if param ~= nil then
		MapExtension.Menu.Tracking.SetSubmenuPosition(param)
		if MapExtension.Menu.Tracking.menus[param].frame ~= nil then
			MapExtension.Menu.Tracking.menus[param].frame:SetVisible(true)
		end
		MapExtension.Menu.Tracking.menus[param].line.SetHighlight(true)
	end

	MapExtension.Menu.Tracking.SelectedSubmenu = param
end

function MapExtension.Menu.Tracking.SetSubmenuPosition (param)
	if param ~= nil then
		if MapExtension.Menu.Tracking.menus[param].frame ~= nil then
			MapExtension.Menu.Tracking.menus[param].frame:ClearPoint("TOPLEFT")
			MapExtension.Menu.Tracking.menus[param].frame:SetPoint("TOPLEFT", MapExtension.Menu.Tracking.menus[param].line, "TOPLEFT", iif(MapExtension.AE.UI.Window:GetLeft() + MapExtension.AE.UI.Window:GetWidth() / 2 < UIParent:GetWidth() / 2, 209, -305), iif(MapExtension.AE.UI.Window:GetTop() + MapExtension.AE.UI.Window:GetHeight() * .75 < UIParent:GetHeight() / 2, -10, 43 - MapExtension.Menu.Tracking.menus[param].frame:GetHeight()))
		end
	end
end

function MapExtension.Menu.Tracking.OnFilterChange (ctrl, param)
	MapExtensionUISettings.tracking[param] = ctrl.checkbox:GetChecked()
	MapExtension.Tracking.ApplyFilter()
end

function MapExtension.Menu.Tracking.UpdateCounters ()
	for k, v in pairs(MapExtension.Tracking.AchievementList) do
		if MapExtension.Menu.Tracking.menus[k] ~= nil then
			MapExtension.Menu.Tracking.menus[k].field:SetText("" .. v.completed .. " / " .. v.count)
		end
	end
end

function MapExtension.Menu.Tracking.UpdateSubCounters ()
	for k, v in pairs(MapExtension.Tracking.ScanList) do
		if MapExtension.Menu.Tracking.fields[k] ~= nil then
			MapExtension.Menu.Tracking.fields[k]:SetText("" .. v.count)
		end
	end
end