MapExtension.Messenger = {
	MessageVersion = MapExtensionAddon.identifier .. "Version",
	MessageRare = MapExtensionAddon.identifier .. "Rare",
	AvailableVersion = MapExtensionAddon.toc.Version,
	QueueTimer = Inspect.Time.Real(),
	IgnoreList = {}
}

function MapExtension.Messenger.Send (identifier, data)
	if type(data) == "table" then data = MapExtension.Utils.Serialize(data, "") end
	MapExtension.Messenger.toSend = { identifier = identifier, data = data }
	MapExtension.Messenger.QueueTimer = Inspect.Time.Real()
	Command.Message.Broadcast("guild", nil, identifier, data, MapExtension.Messenger.SendCallback)
end

function MapExtension.Messenger.SendCallback (failure, message)
	if failure == false or failure == nil then MapExtension.Messenger.toSend = nil end
end

function MapExtension.Messenger.SendQueue ()
	if Inspect.System.Watchdog() > 0.1 and Inspect.Time.Real() - MapExtension.Messenger.QueueTimer > 1 and MapExtension.Messenger.toSend ~= nil then
		MapExtension.Messenger.QueueTimer = Inspect.Time.Real()
		Command.Message.Broadcast("guild", nil, MapExtension.Messenger.toSend.identifier, MapExtension.Messenger.toSend.data, MapExtension.Messenger.SendCallback)
	end
end

function MapExtension.Messenger.Receive (handle, from, type, channel, identifier, data)
	if identifier == MapExtension.Messenger.MessageVersion then
		if MapExtension.Messenger.ParseVersion(data) > MapExtension.Messenger.ParseVersion(MapExtension.Messenger.AvailableVersion) then
			MapExtension.Messenger.AvailableVersion = data
			if MapExtensionUISettings.flags.checkVersion then
				Command.Console.Display("general", true, "<font color=\"#AD48FB\">" .. MapExtension.Data.Language.Current.Messenger1 .. MapExtensionAddon.name .. MapExtension.Data.Language.Current.Messenger2 .. MapExtensionAddon.toc.Version .. MapExtension.Data.Language.Current.Messenger3 .. data .. "</font>", true)
			end
		end
	end

	if identifier == MapExtension.Messenger.MessageRare then
		data = MapExtension.Utils.Deserialize(data)
		if not MapExtension.Messenger.IgnoreList[data.id] and MapExtensionUISettings.flags.rareNotification and (not MapExtension.Events.Achievement.ReqList[data.name] or not MapExtensionUISettings.flags.filter) and MapExtension.Data.Zones[data.zoneId] ~= nil then
			Command.Console.Display("general", true, "<font color=\"#AD48FB\">" .. iif(data.player == Inspect.Unit.Detail("player").name, MapExtension.Data.Language.Current.Messenger4, data.player)  .. MapExtension.Data.Language.Current.Messenger5 .. MapExtension.Tracking.ScanList[data.name].name .. MapExtension.Data.Language.Current.Messenger6 .. data.x .. ", " .. data.y .. " (" .. MapExtension.Data.Zones[data.zoneId][MapExtension.AE.Language] .. iif(data.shard == nil, "", MapExtension.Data.Language.Current.Messenger6 .. (data.shard or "")) .. ")</font>", true)
			MapExtension.Messenger.IgnoreList[data.id] = true
		end
	end
end

function MapExtension.Messenger.ParseVersion (data)
	local i1, i2, high, mid, low = string.find(data, "(%d+).(%d+).(%d+)")
	high = tonumber(high) or 0
	mid = tonumber(mid) or 0
	low = tonumber(low) or 0
	return high * 10000 + mid * 100 + low
end
