MapExtension.Utils = {}

function MapExtension.Utils.Serialize (obj, path)
	local result = ""
	for k, v in pairs(obj) do
		local val = tostring(v)
		local name = iif(path == "", "", path .. ".") .. k
		if type(v) == "table" then
			result = result .. MapExtension.Utils.Serialize(v, name)
		else
			result = result .. name .. "=" .. val .. ","
		end
	end
	return result
end

function MapExtension.Utils.Deserialize (obj)
	local val = {}
	string.gsub(obj, "[,]?([^=]*)=([^,]*)", function (a,b) val[a]=b end)
	return val
end

function MapExtension.Utils.GetCurrentShard ()
	local shard = Inspect.Shard()
	if shard ~= nil then shard = shard.name end

	local player = Inspect.Unit.Detail("player")
	if player.zone ~= nil then
		local zone = Inspect.Zone.Detail(player.zone)
		if zone.name ~= nil then
			local consoles=Inspect.Console.List()
			for cid, flag in pairs(consoles) do
				local console = Inspect.Console.Detail(cid)
				if console.channel then
					for cname, flag in pairs(console.channel) do
						if (cname:sub(1, zone.name:len() + 1) == zone.name .. "@") then
							shard = cname:sub(zone.name:len()+2)
						end
					end
				end
			end
		end
	end

	return shard
end

function tablelength(T)
	local count = 0
	if T ~= nil then
		for _ in pairs(T) do count = count + 1 end
	end
	return count
end

function iif(condition, trueExpression, falseExpression)
	if condition then  
		return trueExpression
	else  
		return falseExpression
	end  
end

function ifnull(expression1, expression2)
	if expression1 == nil then  
		return expression2
	else  
		return expression1
	end  
end

function string.trim(s)
	return (s:gsub("^%s*(.-)%s*$", "%1"))
end
